package me.th0th.rnunityads;

import android.support.annotation.Nullable;

import com.facebook.react.bridge.Arguments;
import com.facebook.react.bridge.Callback;
import com.facebook.react.bridge.ReactApplicationContext;
import com.facebook.react.bridge.ReactContextBaseJavaModule;
import com.facebook.react.bridge.ReactMethod;
import com.facebook.react.bridge.WritableMap;
import com.facebook.react.modules.core.DeviceEventManagerModule;

import com.unity3d.ads.UnityAds;
import com.unity3d.ads.IUnityAdsListener;

public class RNUnityAdsModule extends ReactContextBaseJavaModule implements IUnityAdsListener {
    @Override
    public String getName() {
        return "RNUnityAds";
    }

    public RNUnityAdsModule(ReactApplicationContext reactContext) {
        super(reactContext);
    }

    private void sendEvent(String eventName, @Nullable WritableMap params) {
        getReactApplicationContext().getJSModule(DeviceEventManagerModule.RCTDeviceEventEmitter.class).emit(eventName, params);
    }

    // react methods
    @ReactMethod
    public void init(String gameID) {
        UnityAds.initialize(getCurrentActivity(), gameID, this, true);
    }

    @ReactMethod
    public void show() {
        if (UnityAds.isReady()) {
            UnityAds.show(getCurrentActivity());
        }
    }

    @ReactMethod
    public void isReady(final Callback callback) {
        callback.invoke(UnityAds.isReady());
    }

    // listener methods
    @Override
    public void onUnityAdsReady(final String zoneId) {

    }

    @Override
    public void onUnityAdsStart(String zoneId) {

    }

    @Override
    public void onUnityAdsFinish(String zoneId, UnityAds.FinishState result) {

    }

    @Override
	public void onUnityAdsError(UnityAds.UnityAdsError error, String message) {
        WritableMap event = Arguments.createMap();

        event.putString("error", message);

        sendEvent("onError", event);
	}
}
